package application;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.ToggleGroup;
import javafx.scene.image.*;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Font;

public class FenetrePartie {
	
	/* --------------------------------------------------- Attributs ---------------------------------------------------------*/
	/*------------------------------------------------------------------------------------------------------------------------*/
	private int fenX; 		//Dimension axe x de la fentre
	private static int fenY; 		// idem axe y
	
	//Scene et root obligatoirement en static pour pouvoir g�rer les affichages
	//dans la classe jetonMenu
	private static Group root; 				
	private static Scene scene;
	
	private Plateau plateau;
	private JetonMenu jetonMenu;
	public static Jeton jetonTmp;
	public static Coup coupTmp;
	
	private Joueur joueur1;
	private Joueur joueur2;
	
	//La variable compteur permet de savoir qui joue ou choisie :
	// - 0 : joueur 1 choisit la pièce pour joueur 2
	// - 1 : joueur 2 joue
	// - 2 : joueur 2 choisit la pièce pour joueur 1
	// - 3 : joueur 1 joue
	
	public static int compteur;
	public static int nbTour;
	
	private Jeton[][] grilleJetonsPlaces;
	public Jeton[][] getGrilleJetonsPlaces() { return grilleJetonsPlaces;}
	public Jeton getGrilleJetonsPlacesIJ(int i, int j) {return grilleJetonsPlaces[i][j];}
	public void setGrilleJetonsPlacesIJ(int x, int y, Jeton j) {this.grilleJetonsPlaces[x][y] = j;}	
	private boolean victory;
	
	/* --------------------------------------------------- Accesseurs --------------------------------------------------------*/
	/*------------------------------------------------------------------------------------------------------------------------*/
	//Accesseurs lecture
	public int getFenX() { return fenX;}
	public static int getFenY() { return fenY;}
	public static Group getRoot() { return root;}
	public static Scene getScene() { return scene;}
	public Plateau getPlateau() {return plateau;}
	public JetonMenu getJetonMenu() { return jetonMenu;}
	public Jeton getJetonTmp() { return jetonTmp;}
	public Joueur getJ1() {return joueur1;}
	public Joueur getJ2() {return joueur2;}
	
	//Accesseurs ecriture
	public void setFenX(int x) {fenX = x;}
	public void setFenY(int x) {fenY = x;}
	public void setJetonTmp(Jeton j) { jetonTmp = j;}
	
	
	/* -------------------------------------------------- CONSTRUCTEUR -------------------------------------------------------*/
	/*------------------------------------------------------------------------------------------------------------------------*/

	public FenetrePartie (int x, int y, Joueur joueur1, Joueur joueur2, boolean c) {
		//"c" est la variable bool pour savoir si la partie est chargée ou pas.
		fenX = x;
		fenY = y;
		compteur = 0;

		this.joueur1 = joueur1;
		this.joueur2 = joueur2;
		//joueur1.setPartie(this);
		//joueur2.setPartie(this);
		
		
		/*------------------------------------------ Creation de la fenetre ----------------------------------------*/
		root = new Group();
		scene = new Scene(root,fenX,fenY);
		
		/*---------------------------------------------------*/
		/* ------------------- Plateau ----------------------*/
		plateau = new Plateau(new Rectangle(5,5,fenY,fenY), new Rectangle(0,0,10,10), new Label("Victoire !"));
		/*---------------------------------------------------*/
		/* ---------------- Menu de Jeton -------------------*/
		jetonMenu = new JetonMenu(
			new Rectangle(fenY+10,5,fenX-fenY,fenY/4),
			new Rectangle(fenY+10,25+(fenY/2),fenX-fenY,fenY/4),
			new Rectangle(fenY+10,15+(fenY/4),fenX-fenY,fenY/4),
			this
		);
		
		jetonTmp = new Jeton();
		
		//setPlateau
		setPlateau();
		
		//set menu des jetons
			//mise en forme du menu (couleur, taille...)
		setJetonMenu();
			//affiche les images des jetons sur les boutons du menu
		getJetonMenu().setImagesBoutonsJetons();
			//positionnement des boutons
		getJetonMenu().positionnerBoutonJetons(getFenY());
			//Set de l'image 3D lors de la sélection du jeton
		getJetonMenu().setJetonMenu3D(getFenY());
			//ajout au root des layouts
		rootLeTout();
		
		
		
		jetonMenu.affichageMessageBox(compteur,fenY);
		
		//-----------------------------------------Fin de la création de la fenètre---------------------------------------------
		
		//Zone de sélection et placement du jeton
		Rectangle select = new Rectangle(5,5,fenY,fenY);
		select.setFill(Color.TRANSPARENT);
		getRoot().getChildren().add(select);
		victory = false;
		grilleJetonsPlaces = new Jeton[4][4];
		for(int i=0;i<4;i++) {
			for(int j=0;j<4;j++) {
				grilleJetonsPlaces[j][i]= new Jeton();
				
				grilleJetonsPlaces[j][i].layoutXProperty().bind(select.widthProperty().divide(4).multiply(j+0.18));
				
				grilleJetonsPlaces[j][i].layoutYProperty().bind(select.heightProperty().divide(4).multiply(i+0.19));
				getRoot().getChildren().addAll(grilleJetonsPlaces[j][i]);
			}
		}

		
		select.setOnMouseClicked(e->{
			
			int colonne = (int)(e.getX() / (select.getWidth() / 4));
			int rang = (int)(e.getY() / (select.getHeight() / 4));
			
			if (jetonTmp != null && !getGrilleJetonsPlacesIJ(colonne,rang).getInit() && !victory) {

				
				if (compteur==1) {
					//coupTmp = joueur2.jouerTour(coupTmp);
					placerJeton(getGrilleJetonsPlacesIJ(colonne,rang));
					jetonMenu.setX(colonne);
					jetonMenu.setY(rang);
				}
				
				if (compteur==3) {
					//coupTmp = joueur1.jouerTour(coupTmp);
					placerJeton(getGrilleJetonsPlacesIJ(colonne,rang));
					jetonMenu.setX(colonne);
					jetonMenu.setY(rang);
					
				}
				
			}
			jetonTmp = null;
			victoireVerif();
						
		});
		
		/*------------------------------Chargement d'une partie---------------------------*/

		if(c) {
			chargementPartie();			
		}
	}
	/*------------------------------------------FIN CONSTRUCTEUR---------------------------------------------------*/
		

		
		
	
	/* ---------------------------------------------------- METHODES PLATEAU ---------------------------------------------------------*/
	/*------------------------------------------------------------------------------------------------------------------------*/
	
	//Construction Plateau et Jeton Menu
	public void setPlateau() {
		this.getPlateau().getGrille().setFill(Color.SADDLEBROWN);
		this.getPlateau().getGrille().setArcHeight(20);
		this.getPlateau().getGrille().setArcWidth(20);
		
		
		
		for (int i=0; i<4;i++) {
			for(int j=0;j<4;j++) {
				this.plateau.setCasesIJ(i,j,new Circle());
				this.getPlateau().getCasesIJ(i,j).setFill(Color.PAPAYAWHIP);
				this.getPlateau().getCasesIJ(i,j).radiusProperty().bind(plateau.getGrille().heightProperty().divide(8).subtract(10));
				this.getPlateau().getCasesIJ(i,j).centerXProperty().bind(plateau.getGrille().widthProperty().divide(4).multiply(j+0.52));
				this.getPlateau().getCasesIJ(i,j).centerYProperty().bind(plateau.getGrille().heightProperty().divide(4).multiply(i+0.52));
			}
		}
	}
	
	/* ---------------------------------------------------- METHODES MENU ---------------------------------------------------------*/
	/*------------------------------------------------------------------------------------------------------------------------*/
	public void setJetonMenu() {
		
		this.getJetonMenu().getPause().setLayoutX(fenY+25);
		this.getJetonMenu().getPause().setLayoutY(getFenY()-50);
		
		//Bouton restart
		this.getJetonMenu().getRestart().setLayoutX(this.getJetonMenu().getPause().getLayoutX()+80);
		this.getJetonMenu().getRestart().setLayoutY(fenY-50);
		this.getJetonMenu().getRestart().setOnAction((ActionEvent e) ->{
			victory=false;
			for(int i=0;i<4;i++) {
				for(int j=0;j<4;j++) {
					getGrilleJetonsPlacesIJ(i,j).removeImage();
				}
			}
			
			jetonMenu.affichageMessageBox(0, fenY);
			compteur=0;
			for(int i=0; i<16;i++) {
				jetonMenu.getTableauBouton(i).setOpacity(1); jetonMenu.getTableauBouton(i).setDisable(false);
			}
			if(!joueur2.getType()) {
				joueur2 = new IA(3);
			}
		});
		
		this.getJetonMenu().getStopSave().setLayoutX(this.getJetonMenu().getRestart().getLayoutX()+80);
		this.getJetonMenu().getStopSave().setLayoutY(fenY-50);
		/* ------------------------------------------------ STOP AND SAVE EVENT (start) -------------------------------------------- */
		this.getJetonMenu().getStopSave().setOnAction((ActionEvent e) ->{
			
			if(!victory) {
				try {
					File saveFile = new File("saveFile.txt");
				
					PrintWriter writer = new PrintWriter(saveFile);
					writer.print(compteur);
					for(int i=0;i<4;i++) {
						for(int j=0;j<4;j++) {
							if(this.getGrilleJetonsPlacesIJ(i,j).getInit()) {
								writer.print(this.getGrilleJetonsPlacesIJ(i, j).getName());
								}
							else {
								writer.print("0000");
							}
						}
					}
					writer.close();
					} catch (IOException e1) {
						// TODO Bloc catch g�n�r� automatiquement
						e1.printStackTrace();
					}
				root.getChildren().clear();
				Main.adMenu();
			}
			
		});
		/* ------------------------------------------------ STOP AND SAVE EVENT (end) -------------------------------------------- */

		this.getJetonMenu().getExit().setLayoutX(this.fenX-50);
		this.getJetonMenu().getExit().setLayoutY(fenY-50);
		this.getJetonMenu().getExit().setOnAction((ActionEvent e) ->{ 
			Main.closeProgram();
		});
		
		this.getJetonMenu().getMenuPrinc().setLayoutX(this.getJetonMenu().getExit().getLayoutX()-150);
		this.getJetonMenu().getMenuPrinc().setLayoutY(fenY-50);
//		this.getJetonMenu().getMenuPrinc().setOnAction((ActionEvent e) ->{ 
//			Main.start();
//		});
		
		
		this.getJetonMenu().setSousMenus(jetonMenu.getMenuJB(), Color.SADDLEBROWN, 20, 20, 0.4f);
		this.getJetonMenu().setSousMenus(jetonMenu.getMenuJN(), Color.PAPAYAWHIP, 20, 20, 0.4f);
		this.getJetonMenu().setSousMenus(jetonMenu.getMenu3D(), Color.AQUA, 20, 20, 0.4f);
	
	}
	
	//On ajoute tous les boutons, rectangles, labels créés à la fenêtre "root"
	public void rootLeTout() {
		getRoot().getChildren().addAll(plateau.getGrille());
		
		for(int i=0;i<4;i++) {
			for(int j=0;j<4;j++) {
				getRoot().getChildren().addAll(plateau.getCasesIJ(i,j));
			}
		}
		
		//--------------------------------Permet la sélection d'un seul bouton à la fois-----------------------------------------------
		ToggleGroup groupeBouton = new ToggleGroup();
		for(int i=0;i<16;i++) {
			jetonMenu.getTableauBouton(i).setToggleGroup(groupeBouton);
		}
		jetonMenu.getMenuPrinc().setOnAction(new EventHandler<ActionEvent>() {
			public void handle(ActionEvent e) {
				root.getChildren().clear();
				Main.adMenu();
			}
		});
		getRoot().getChildren().addAll(jetonMenu.getPause(),jetonMenu.getRestart(),jetonMenu.getStopSave(),jetonMenu.getExit(),jetonMenu.getMenuPrinc());
		getRoot().getChildren().addAll(jetonMenu.getMenuJB(),jetonMenu.getMenuJN());	
		for(int i = 0; i < 16; i++) {
			//this.getRoot().getChildren().addAll(jetonMenu.getTableauDeJeton(i));
			getRoot().getChildren().addAll(jetonMenu.getTableauBouton(i));
			getRoot().getChildren().addAll(jetonMenu.getTableauImageView(i));
		}
		getRoot().getChildren().addAll(jetonMenu.getMenu3D(), jetonMenu.getIm3D());
		
		for(int i = 0; i<6; i++) {
			getRoot().getChildren().addAll(jetonMenu.getMsgBox(i));
		}
		
	}
	
	//---------------------------------Pour placer un jeton J sur le plateau------------------------------------
	public void placerJeton(Jeton j) {
		
		String l = jetonTmp.getIm();
		Image im = new Image(l);
	   
	   j.setCouleur(jetonTmp.getCouleur());
	   j.setTaille(jetonTmp.getTaille());
	   j.setPleine(jetonTmp.getPleine());
	   j.setForme(jetonTmp.getForme());
	   j.setInit(true);
	  
	   j.putThisImage(im);
	   j.setOpacity(1);
	   
	   
	   int i = 0;
	   while(JetonMenu.tableauDeJeton[i] != jetonTmp && i<16) {
		   i++;
	   }
	  
	   jetonMenu.getTableauBouton(i).setOpacity(0.3);
	   jetonMenu.getTableauBouton(i).setDisable(true);
	   jetonMenu.getTableauBouton(i).setSelected(false);
	   
   }
	
	public void switchCompteurFen() {
		switch(compteur) {
		case 1:{
			compteur=2;
			}break;
		case 3:{
			compteur=0;
			}break;
		}
	}
	
	//-----------------------------------------Condition de victoire---------------------------------------
	public boolean victoireVerif () {
		
		//-------------------------Verification victoire
		//boolean victory = false;
		int i =0;
		//Lignes horizontales
		while(i<4 && !victory) {
			if(ligneGagnante(getGrilleJetonsPlacesIJ(i,0),getGrilleJetonsPlacesIJ(i,1),getGrilleJetonsPlacesIJ(i,2),getGrilleJetonsPlacesIJ(i,3))) {
				System.out.println(i);
				victory = true;
			}
			i++;
		}
		i=0;
		//Lignes verticales
		while(i<4 && !victory) {
			if(ligneGagnante(getGrilleJetonsPlacesIJ(0,i),getGrilleJetonsPlacesIJ(1,i),getGrilleJetonsPlacesIJ(2,i),getGrilleJetonsPlacesIJ(3,i))) {
				victory = true;
			}
			i++;
		}
		//lignes diagonales
		if(!victory) {if(ligneGagnante(getGrilleJetonsPlacesIJ(0,0),getGrilleJetonsPlacesIJ(1,1),getGrilleJetonsPlacesIJ(2,2),getGrilleJetonsPlacesIJ(3,3))) { victory = true; }}
		if(!victory) {if(ligneGagnante(getGrilleJetonsPlacesIJ(3,0),getGrilleJetonsPlacesIJ(2,1),getGrilleJetonsPlacesIJ(1,2),getGrilleJetonsPlacesIJ(0,3))) { victory = true; }}
		
		
		if(!victory){
			switchCompteurFen();
			jetonMenu.affichageMessageBox(compteur,fenY);
		}
		else {
			//En cas de victoire on désactive les boutons
			for(int h=0;h<16;h++) {
				jetonMenu.getTableauBouton(h).setOpacity(0.3);
				jetonMenu.getTableauBouton(h).setDisable(true);
				jetonMenu.getTableauBouton(h).setSelected(false);
			}
			//et on affiche le gagnant
			jetonMenu.affichageMessageBox(4, fenY);
		}
		
		return victory;

		
	}
	
	public void setLigneGagnante(Jeton j, Jeton k, Jeton l, Jeton m) {
		j.setJetonVictoire(true);k.setJetonVictoire(true);l.setJetonVictoire(true);m.setJetonVictoire(true);
	}
	
	public boolean ligneGagnante(Jeton j, Jeton k, Jeton l, Jeton m){
		if(j.getInit() && k.getInit() && l.getInit() && m.getInit()) {
			
			if((j.getCouleur() && k.getCouleur() && l.getCouleur() && m.getCouleur()) || (!j.getCouleur() && !k.getCouleur() && !l.getCouleur() && !m.getCouleur())) {setLigneGagnante(j,k,l,m);surbrillance();/*System.out.println("victoire couleur");*/return true;}
		
			if((j.getTaille() && k.getTaille() && l.getTaille() && m.getTaille()) || (!j.getTaille() && !k.getTaille() && !l.getTaille() && !m.getTaille())) {setLigneGagnante(j,k,l,m);surbrillance();/*System.out.println("victoire taille");*/return true;}
		
			if((j.getPleine() && k.getPleine() && l.getPleine() && m.getPleine()) || (!j.getPleine() && !k.getPleine() && !l.getPleine() && !m.getPleine())) {setLigneGagnante(j,k,l,m);surbrillance();/*System.out.println("victoire creuse/pleine");*/return true;}
		
			if((j.getForme() && k.getForme() && l.getForme() && m.getForme()) || (!j.getForme() && !k.getForme() && !l.getForme() && !m.getForme())) {setLigneGagnante(j,k,l,m);surbrillance();/*System.out.println("victoire forme");*/return true;}
		}
		return false;
		
	}
	
	public void surbrillance() {
		for(int i=0; i<4; i++) {
			for(int j=0; j<4;j++) {
				if(getGrilleJetonsPlacesIJ(i,j).getInit() && !getGrilleJetonsPlacesIJ(i,j).getJetonVictoire()) {
					getGrilleJetonsPlacesIJ(i,j).setOpacity(0.3);
				}
			}
		}
	}
	
	//--------------------------------------permet le chargement d'une partie-----------------------------------------------------
	public void chargementPartie() {
		InputStreamReader characterStream = null;
	    try {
	        FileInputStream byteStream = new FileInputStream("saveFile.txt");
	                
	        characterStream = new InputStreamReader(byteStream, "UTF8");
	        int character;
	        int i = 0; int j = 1;
	        String temp = "";
	        while ((character = characterStream.read()) != -1) {
	            if(i==0) { //Remise du compteur
	            	compteur = Character.getNumericValue((char)character);
	            	jetonMenu.affichageMessageBox(compteur,fenY);
	            }
	            else {
	            	temp+=(char)character;
	            	if(i==4) {
	            		if(!temp.equals("0000")) {
	            			int k=0;
	            			while(!temp.equals(JetonMenu.getTableauDeJeton(k).getName())) {
	            				k++;
	            			}
	            			jetonTmp = JetonMenu.getTableauDeJeton(k);
	            			String l = jetonTmp.getIm();
				            Image im = new Image(l); 
			                getGrilleJetonsPlacesIJ(colum(j),ligne(j)).setCouleur(jetonTmp.getCouleur());
			                getGrilleJetonsPlacesIJ(colum(j),ligne(j)).setTaille(jetonTmp.getTaille());
			                getGrilleJetonsPlacesIJ(colum(j),ligne(j)).setPleine(jetonTmp.getPleine());
			                getGrilleJetonsPlacesIJ(colum(j),ligne(j)).setForme(jetonTmp.getForme());
			                getGrilleJetonsPlacesIJ(colum(j),ligne(j)).setInit(true);
			                getGrilleJetonsPlacesIJ(colum(j),ligne(j)).putThisImage(im);
			                getGrilleJetonsPlacesIJ(colum(j),ligne(j)).setOpacity(1);
			                
			                jetonMenu.getTableauBouton(k).setOpacity(0.3);
			                jetonMenu.getTableauBouton(k).setDisable(true);
			                jetonMenu.getTableauBouton(k).setSelected(false);
			                
			                jetonTmp=null;
	            			
	            		}
	            		temp = "";
	            		j++;
	            	}
	            }
	            
	            if(i!=4) {i++;}
	            else {i=1;}
	            
	        }
	    }catch (IOException e1) {
			// TODO Bloc catch g�n�r� automatiquement
			e1.printStackTrace();
		}
	}
	
	public final int colum(int x) {
		if(x%4 == 0) {
			return (x/4)-1;
		}
		else {
			return x/4;
		}
	}
	
	public final int ligne(int x) {
		if(x%4 == 0) {
			return 3;
		}
		else {
			return (x%4)-1;
		}
	}
	
}
