package application;

import javafx.scene.image.Image;
import javafx.scene.image.ImageView;

public class Jeton extends ImageView{
	
	/* --------------------------------------------------- Attributs ---------------------------------------------------------*/
	/*------------------------------------------------------------------------------------------------------------------------*/
	private String name;
	private boolean couleur; // true = Black
	private boolean taille; // true = Grand
	private boolean pleine; // true = Plein
	private boolean forme; // true = carr
	private boolean initialise; 
	private boolean jetonVictoire; //Utiliser dans la methode "surbrillance" (plateau)
	private String im2D = "";
	
	/* -------------------------------------------------- CONSTRUCTEUR -------------------------------------------------------*/
	/*------------------------------------------------------------------------------------------------------------------------*/
	
	public Jeton() {
		couleur = false;
		pleine = false;
		taille = false;
		forme = false;
		name = "NpCr";
		initialise = false;
	}
	
	public Jeton(boolean c, boolean t, boolean p, boolean f) {
		initialise = true;
		couleur = c;
		taille = t;
		pleine = p;
		forme = f;
		jetonVictoire=false;
		if(c) {name = "B";}
		else {name = "N";}
		if(t) {name += "g";}
		else {name += "p";}
		if(p) {name += "P";}
		else {name += "C";}
		if(f) {name += "c";}
		else {name += "r";}
	}
	
	/* --------------------------------------------------- Accesseurs --------------------------------------------------------*/
	/*------------------------------------------------------------------------------------------------------------------------*/
	//Accesseurs lecture
	public boolean getCouleur() {
		return couleur;
	}
	public boolean getTaille() {
		return taille;
	}
	public boolean getPleine() {
		return pleine;
	}
	public boolean getForme() {
		return forme;
	}
	public String getName() {
		return name;
	}
	public boolean getInit() {
		return initialise;
	}
	public String getIm() {
		return im2D;
	}
	public boolean getJetonVictoire(){
		return jetonVictoire;
	}

	
	//Accesseurs ecriture
	public void setIm(String l) {
		im2D = l;
	}
	public void setInit(boolean b) {
		initialise = b;
	}
	
	public void setCouleur(boolean b) {
		couleur = b;
		if(b) { name = "B"+name.substring(1);}
		else {name = "N"+name.substring(1);}
	}
	public void setTaille(boolean b) {
		taille = b;
		if(b) { name = name.substring(0,1)+"g"+name.substring(2);}
		else {name = name.substring(0,1)+"p"+name.substring(2);}
	}
	public void setPleine(boolean b) {
		pleine = b;
		if(b) { name = name.substring(0,2)+"P"+name.substring(3);}
		else {name = name.substring(0,2)+"C"+name.substring(3);}
	}
	public void setForme(boolean b) {
		forme = b;
		if(b) { name = name.substring(0,3)+"c";}
		else {name = name.substring(0,3)+"r";}
	}
	
	public void setJetonVictoire(boolean b) {
		jetonVictoire = b;
	}
	
	/* ---------------------------------------------------- METHODES ---------------------------------------------------------*/
	/*------------------------------------------------------------------------------------------------------------------------*/
	public void putThisImage(Image i) {
		this.setImage(i);
	}
	
	public void removeImage() {
		this.setImage(null);
		this.setInit(false);
		this.setJetonVictoire(false);
	}
	
}