package application;
	
import javafx.application.Application;
import javafx.application.Platform;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ToggleGroup;
import javafx.scene.image.Image;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

public class Main extends Application{
	static Stage primaryStage;
	static VBox menu = new VBox();
	static Group root = new Group();
	static Scene scene;
	
	@Override
	public void start(Stage pStage) {
		try {
			primaryStage = pStage;

			//--------------------------------Creations layout et boutons----------------------------------------
			
			
			
			menu.setPadding(new Insets(300,20,20,330));
			menu.setSpacing(10);
			Button boutonJouer = new Button("JOUER");
			Button boutonCharger = new Button("CHARGER");
			Button boutonOption = new Button("OPTION");
			Button boutonExit = new Button("EXIT");
			menu.getChildren().addAll(boutonJouer,boutonCharger,boutonOption,boutonExit);
			
			HBox choix = new HBox();
			choix.setPadding(new Insets(300,20,20,250));
			choix.setSpacing(10);
			Button boutonJoueurVS = new Button("Joueur Vs Joueur");
			Button boutonCpuVS = new Button("Partie contre ordinateur");
			Button precedentChoix = new Button("Retour");
			choix.getChildren().addAll(boutonJoueurVS,boutonCpuVS,precedentChoix);
			root.getChildren().add(menu);
			//--------------------------------------------------------------------------------------------------
			//creation de la scene
			scene = new Scene(root,800,800);
			//lien vers la feuille css
			scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());
			//ajout de la scene au stage
			primaryStage.setScene(scene);
			primaryStage.setTitle("Quarto");
			//affichage du stage
			primaryStage.show();
			
			
			
			//--------------------------Actions des differents boutons------------------------------------------
					//Groupe menu
			boutonJouer.setOnAction(new EventHandler<ActionEvent>() {
				public void handle(ActionEvent e) {
					root.getChildren().remove(menu);
					root.getChildren().add(choix);
				}
			});

			boutonExit.setOnAction(e -> closeProgram());
					//Groupe choix
			precedentChoix.setOnAction(new EventHandler<ActionEvent>() {
				public void handle(ActionEvent e) {
					root.getChildren().remove(choix);
					root.getChildren().add(menu);
				}
			});
			// Bouton JoueurVsJoueur (et donc lancement de la partie)
			// Bouton JoueurVsJoueur (et donc lancement de la partie)
			boutonJoueurVS.setOnAction(new EventHandler<ActionEvent>() {
				public void handle(ActionEvent e) {
					root.getChildren().remove(choix);

					int x = 1500;
					int y = 900;
					FenetrePartie fenPartie = new FenetrePartie(x,y,new JoueurHumain("Joueur1"), new JoueurHumain("Joueur2"), false);
					fenPartie.getScene().getStylesheets().add(getClass().getResource("application.css").toExternalForm());
					
					primaryStage.setTitle("Quarto");
					primaryStage.setScene(fenPartie.getScene()); 	//mettre le contenu dans la fenetre
					primaryStage.setResizable(false); 				// permet que la fenetre ne soit pas "resizable"
					primaryStage.show();							// affiche la fenetre
					
					
				}
			});

			// Bouton JoueurVsIA (et donc lancement de la partie)
			boutonCpuVS.setOnAction(new EventHandler<ActionEvent>() {
				public void handle(ActionEvent e) {
					root.getChildren().remove(choix);

					int x = 1500;
					int y = 900;
					FenetrePartie fenPartie = new FenetrePartie(x,y, new JoueurHumain("Joueur1"), new IA(3), false);
					fenPartie.getScene().getStylesheets().add(getClass().getResource("application.css").toExternalForm());
					
					primaryStage.setTitle("Quarto");
					primaryStage.setScene(fenPartie.getScene()); 	//mettre le contenu dans la fenetre
					primaryStage.setResizable(false); 				// permet que la fenetre ne soit pas "resizable"
					primaryStage.show();							// affiche la fenetre
					
					
				}
			});
			
			boutonCharger.setOnAction(new EventHandler<ActionEvent>() {
				public void handle(ActionEvent e) {
					root.getChildren().remove(choix);

					int x = 1500;
					int y = 900;
					FenetrePartie fenPartie = new FenetrePartie(x,y,new JoueurHumain("Joueur1"), new JoueurHumain("Joueur2"),true);
					fenPartie.getScene().getStylesheets().add(getClass().getResource("application.css").toExternalForm());
					
					primaryStage.setTitle("Quarto");
					primaryStage.setScene(fenPartie.getScene()); 	//mettre le contenu dans la fenetre
					primaryStage.setResizable(false); 				// permet que la fenetre ne soit pas "resizable"
					primaryStage.show();							// affiche la fenetre
					
					
				}
			});

			//--------------------------FIN Actions des differents boutons----------------------------------------
		} 
		
		catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void adMenu() {
		primaryStage.setScene(scene);
		root.getChildren().add(menu);
	}
	
	public static void closeProgram() {
		primaryStage.close();
	}
	
	public static void main(String[] args){
		launch(args);
		
	}
	
}